/* File to remove graphs for which there is an  4-wheel.
Compile as 
    cc -o w4f -O4 -DPRUNE=w4f -DMAXN=16 geng.c w4f.c \\
        gtools.o nauty1.o nautil1.o naugraph1.o
   cc -o w4f -O4 -DPRUNE=w4f -DMAXN=16 geng.c w4f.c gtools.o nauty1.o nautil1.o naugraph1.o */
#include "nauty.h"
#include <stdio.h>
int PRUNE (graph *g, int n, int maxn){
  setword escribir[n];
  setword common, common2, common3, common1, common4, common5, common6, common7;
  int v,w,u,i,z, indice, d;
  for(i=n-1; i>2; i--){/*Para todos los vertices salvo para los 3 finales (si existe una rueda, existira un ciclo de 4. Si no existe algun vertice que se encuentre en alguna rueda entre el ultimo  y el 4, no existe ninguna rueda*/
    for (v = i-1; v >= 0; v--){ /*Para todos los vertices*/
      if (((g[i] & bit[v]) == 0)&&(i!=v)){    /* si i no es adyacente a v y no son el mismo */
	common = g[i] & g[v];   /* obtengo los vecinos comunes entre i y v*/
	common1=common; /*los guardo en common1 para que no se borren al hacer el TAKEBIT*/
	while (common){
	  TAKEBIT(w,common);     /*por cada vecino comun de ambos*/	 	 
	  common2=common1 & ~g[w]; /*De entre todos los comunes entre i y v, cojo los que no sean adyacentes a w (que es el comun actual). Asi formamos el cuadrado*/
	  common2=common2 & ~bit[w];
	  common3=common1 & g[w]; /*Obtener los vertices adyacentes a i, v, y w (Son los candidatos a centro de la rueda)*/
	  while(common2){    /*Mientras quede algun vertice almacenado en common2*/
	    TAKEBIT(u, common2); /*Obtener alguno de estos vertices */	 
	    common5=common3 & g[u]; /*Obtenemos todos los centros del grafo*/
	    if(common5){
	      common4=common5; /*Si hay alguno, lo copiamos*/
	      while(common4){ /*Mientras queden centros*/
		TAKEBIT(z, common4); /*Tomamos uno a uno los centros*/
		common6=g[z] & common5; /*Tomamos los adyacentes a dicho centro*/
		common7=common6; /*Copiamos los centros adyacentes al primer centro*/
		while(common7){ /*Mientras queden centros adyacentes al primer centro*/
		  TAKEBIT(d, common7); /*Tomamos un centro adyacente al primer centro*/
		  if(common6 & g[d]) /*Si ese centro es adyacente a algún adyacente al primer centro acabamos*/
		    return 1;
		}		 
	      }
	    }
	  }
	}	       /*necesitamos que algun vertice de common3 sea adyacente a u para cerrar la rueda*/
      }
    }
  }
  return 0;/*En caso contrario, devuelvo falso*/
}
